<?php

namespace EventPortal\Domain\Component\Dropdown;

use EventPortal\Concerns\QueriesJson;
use EventPortal\Domain\Component\Concerns\HasOptions;
use EventPortal\Domain\Component\Input;
use Illuminate\Database\Eloquent\Builder;

class Select extends Input
{
    use HasOptions, QueriesJson;

    const TYPE = 'Select';

    public function __construct(?string $label = null)
    {
        parent::__construct($label);

        $this->lookup(function (Builder $query, $field, $value) {
            return $this->whereJson($query, "{$field}->value", $value);
        });
    }
}
