<?php

namespace EventPortal\Http\Controllers\Admin\EventDelegate;

use EventPortal\Domain\EventDelegate\Actions\TransitionDelegateOnEvent;
use EventPortal\Http\Controllers\Controller;
use Illuminate\Http\RedirectResponse;
use SM\SMException;

class EventDelegateTransitionController extends Controller
{
    public function __invoke(TransitionDelegateOnEvent $action): RedirectResponse
    {
        try {
            $action->execute(request()->event, request()->delegate, request()->type);
        } catch (SMException $exception) {
            report($exception);
        }

        return redirect()
            ->route('admin.event.delegate.show', [
                'event' => request()->event,
                'delegate' => request()->delegate,
            ]);
    }
}
